import os
import sys
import threading
import time

def thisScriptDirectory():
    return os.path.dirname(os.path.abspath(sys.argv[0]))

class SystemEnvironment:
    def __init__(self):
        if os.path.exists("/usr/bin/kdesu"):
            self.sudoGui = "/usr/bin/kdesu"
        elif os.path.exists("/usr/bin/gksudo"):
            self.sudoGui = "/usr/bin/gksudo"
        else:
            raise Exception, _("Cannot find kdesu or gksudo, please install one of them.")
    def getSudoGuiPath(self):
        return self.sudoGui
    
class ConnectionUpdateThread(threading.Thread):
    def __init__(self, *args):
        apply(threading.Thread.__init__, (self,) + args)
        self.mutex = threading.Lock()
        self.forceQuit = False
        self.receivedBytes = ""
        self.onoff = None
        self.address = ""
        self.gateway = ""
        self.rxtx = ""
        self.connectionTime = ""
    def run(self):
        while True:
            self.update()
            sleepTime = 1.0
            timeSlept = 0.0
            while timeSlept < sleepTime:
                self.lock()
                shouldQuit = self.forceQuit
                self.unlock()
                if shouldQuit == True:
                    return
                time.sleep(0.2)
                timeSlept += 0.2
    def terminate(self):
        print "Terminating update thread"
        self.lock()
        self.forceQuit = True
        self.unlock()
        self.join(10.0) #wait maximum 10 seconds for thread to exit
    
    def lock(self):
        self.mutex.acquire()
    def unlock(self):
        self.mutex.release()
        
    def update(self):
        #print "Update..."
        #komenda="ifconfig ppp0 | grep 'RX bytes'"
        #from os import popen
        #wynik = popen(komenda)
        #tmp=' '.join(wynik)
        #tmp=tmp.strip()
        #self.lock()
        #self.receivedBytes = tmp
        #self.unlock()

        komenda2="ifconfig -a ppp0 2>/dev/null | grep 'ppp0' "
        from os import popen
        wynik2 = popen(komenda2)
        ppp="ppp0      Link encap:Point-to-Point Protocol  \n"

        wynik2a=''.join(wynik2)
        
        self.lock()
        if wynik2a == ppp:
            self.onoff = True
        else:
            self.onoff = False
        self.unlock()
        #print "updateThread: onOff=", self.onoff

        komenda="ifconfig ppp0 2>/dev/null | grep 'inet' | awk '{ print $2 }' | awk -F: '{ print $2 } '"
        from os import popen
        wynik = popen(komenda)
        tmp = ' '.join(wynik)
        tmp = tmp.strip()
        self.lock()
        self.address = tmp
        self.unlock()

        #komenda="route | grep 'default'| awk '{ print $8 }'"
        #from os import popen
        #wynik = popen(komenda)
        #tmp = ' '.join(wynik)
        #tmp = tmp.strip()
        #self.lock()
        #self.gateway = tmp
        #self.unlock()
        
        #komenda="netstat -i | grep 'ppp0' |  awk '{ print \"RX:\"$5 \" / TX:\" $9 }'"
        #from os import popen
        #wynik = popen(komenda)
        #tmp = ' '.join(wynik)
        #tmp = tmp.strip()
        #self.lock()
        #self.rxtx = tmp
        #self.unlock()
        
        komenda="ps --no-headers -p  $(cat /var/run/ppp0.pid 2>/dev/null) -o '%t' 2>/dev/null"
        from os import popen
        wynik = popen(komenda)
        tmp = ' '.join(wynik)
        tmp = tmp.strip()
        self.lock()
        self.connectionTime = tmp
        self.unlock()
